<?php
/** 
 * The Auth_obm class transparently logs users in to Horde using an
 * emulated SSO server. The SSO server is set into OBM  .
 * If the user is not logged into OBM, this driver redirect the user 
 * to the OBM login page.
 *
 * FIXME : This is not valid
 * Optional parameters:<pre>
 *   'username'     The username to authenticate everyone as.
 *                  DEFAULT: 'horde_user'
 *   'password'     The password to record in the user's credentials.
 *                  DEFAULT: none
 *   'requestuser'  If true, allow username to be passed by GET, POST or
 *                  cookie.</pre>
 *
 *
 * $Horde: framework/Auth/Auth/auto.php,v 1.12.4.8 2006/01/01 21:28:07 jan Exp $
 *
 * Copyright 1997-2007 Aliasource <mehdi.rande@aliasource.fr>
 *
 * See the enclosed file COPYING for license information (LGPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/lgpl.html.
 *
 * @author  Mehdi Rande <mehdi.rande@aliasource.fr>
 * @since   Horde 2.2
 * @package Horde_Auth
 */

define('IMP_BASE', HORDE_BASE.'/imp');
require_once IMP_BASE.'/lib/IMP.php';
require_once IMP_BASE.'/lib/Auth/imp.php';


class Auth_obm extends Auth_imp {
  /**
   * An array of capabilities, so that the driver can report which
   * operations it supports and which it doesn't.
   *
   * @var array
   */
  var $capabilities = array(
    'add'           => false,
    'update'        => false,
    'resetpassword' => false,
    'remove'        => false,
    'list'          => false,
    'transparent'   => true);
  /**
   * Constructs a new Automatic authentication object.
   *
   * @param array $params  A hash containing parameters.
   */
  function Auth_obm($params = array()) {
    $this->_setParams($params);
  }


  /**
   * Set parameters for the Auth_auto object.
   *
   * @access private
   *
   * @param array $params  Parameters. None currently required;
   *                       'username', 'password', and 'requestuser' are optional.
   */
  function _setParams($params) {
    if (!isset($params['username'])) {
      $params['username'] = 'horde_user';
    }
    $this->_params = $params;
  }

  /**
   * Automatic authentication: Set the user allowed IP block.
   *
   * @return boolean  Whether or not the client is allowed.
   */
  function transparent() {
    if(!isset($_REQUEST["ticket"])) {
      return false;
    }

    $credential = $this->checkAuthentication($_REQUEST["ticket"]);
    if(!$credential['login']) {
      return false;
    }
    $this->setAuth($credential['login'],
      array('transparent' => 1,
      'password' => $credential["password"]
      )
    );
    #unknow FIX 
    #return parent::authenticate();
    return true;
  }   

  /**
   * Check the given ticket against the OBM SSO server.
   * If ok, get the username else return false 
   */
  function checkAuthentication($ticket) {
    
    $baseUrl =  $this->_params['obm']['external-protocol'].'://'.$this->_params['obm']['external-url'].$this->_params['obm']['obm-prefix'];
    $url = $baseUrl."sso/sso_index.php?action=validate&ticket=$ticket";

    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $buf = curl_exec ($ch);
    if ( $buf === FALSE || $buf == "") {
      return false;
    }
    curl_close ($ch);

    if($buf == "invalidOBMTicket") {
      return false;
    }

    parse_str($buf,$values);

    return $values;
  }   

}
?>
